#define     STRICT
#include    <windows.h>
#include    <ddraw.h>
#include    <mmsystem.h>
#include    "ddutil.h"
#include    "draw.h"
#include    "releasedraw.h"
#include    "state.h"

#define SAFE_DELETE(p)  { if (p) { delete (p);     (p)=NULL; } }
#define SAFE_RELEASE(p) { if (p) { (p)->Release(); (p)=NULL; } }



LRESULT     CALLBACK MainWndProc(HWND, UINT, WPARAM, LPARAM);
HRESULT     WinInit(HINSTANCE hInst, int nCmdShow, HWND* phWnd);
HRESULT     InitDirectDraw(HWND hWnd);
VOID        FreeDirectDraw();
HRESULT     DisplayFrame();

int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR pCmdLine, int nCmdShow)
{   MSG     msg;
    HWND    hWnd;

    if (FAILED(WinInit(hInst, nCmdShow, &hWnd)))    return FALSE;

    if (FAILED(InitDirectDraw(hWnd)))
    {   if (g_pDisplay)
            g_pDisplay->GetDirectDraw()->SetCooperativeLevel(NULL, DDSCL_NORMAL);

        ERMSG("DirectDraw init failed. The sample will now exit.");
        return FALSE;
    }

    while(TRUE)
    {   if (PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE))
        {   if (0 == GetMessage(&msg, NULL, 0, 0))  return (int)msg.wParam;
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        }
        else
        {   if (g_bActive)
            {   if (FAILED(DisplayFrame()))
                {   SAFE_DELETE(g_pDisplay);
                    ERMSG("Displaying the next frame failed. The sample will now exit.");
                    return FALSE;
                }
            }
            else    WaitMessage();
        }
    }
}

HRESULT WinInit(HINSTANCE hInst, int nCmdShow, HWND* phWnd)
{   WNDCLASS wc;
    HWND     hWnd;

    wc.lpszClassName = TEXT("BMP View");
    wc.lpfnWndProc   = MainWndProc;
    wc.style         = CS_VREDRAW | CS_HREDRAW;
    wc.hInstance     = hInst;
    wc.hIcon         = LoadIcon(NULL,IDI_APPLICATION);
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
    wc.lpszMenuName  = NULL;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;

    if (RegisterClass(&wc) == 0)    return E_FAIL;

    hWnd = CreateWindowEx(0, TEXT("BMP View"), TEXT("DirectDraw BMP View"),
                 WS_POPUP, CW_USEDEFAULT, CW_USEDEFAULT,
                 CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInst, NULL);
    if (hWnd==NULL)   return E_FAIL;

    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);
    *phWnd = hWnd;

    return S_OK;
}


VOID FreeDirectDraw()
{   SAFE_DELETE(g_pBmpa);
    SAFE_DELETE(g_pDisplay);
}

LRESULT CALLBACK MainWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{   switch(msg)
    {   case WM_KEYDOWN:
			switch(wParam)
			{
				case VK_ESCAPE:
					PostMessage(hWnd, WM_CLOSE, 0, 0);
					return 0L;

				case 'A':
					if ( state != 1){
						film = 1;
						now_n = 0;
					}
					film_c = 1;
					num_c = 1;
					state = 1;
					break;

				case 'S':
					if ( state != 2){
						film = 1;
						film_r = 1;
						now_n = 0;
					}
					if (film_r >= 2){
						if (film_c == 1){
							attack = 2;
							num_c = 2;
						}
						if (film_c == 2){
							attack = 3;
							num_c = 3;
						}
					}
					state = 2;
					break;
				
				case VK_LEFT:
					if ( state != 2 ){
						if( state != 3){
							film = 1;
							film_r = 1;
							state = 3;
							now_n = 0;
						}
						p_x -= 5;
					}
					break;
				case VK_RIGHT:
					if ( state != 2 ){
						if( state != 3){
							film = 1;
							film_r = 1;
							state = 3;
							now_n = 0;
						}
						p_x += 5;
					}
					break;
				case VK_UP:
					if ( state != 2 ){
						if( state != 3){
							film = 1;
							film_r = 1;
							state = 3;
							now_n = 0;
						}
						p_y -= 3;
					}
					break;
				case VK_DOWN:
					if ( state != 2 ){
						if( state != 3){
							film = 1;
							film_r = 1;
							state = 3;
							now_n = 0;
						}
						p_y += 3;
					}
					break;
			}
			case WM_KEYUP:
				switch(lParam)
				{
					case VK_RIGHT:
						if ( state == 3 ){
							state = 1;
							film = 1;
							film_r = 1;
							film_c = 1;
						}
				}

			case WM_SIZE:
             if (SIZE_MAXHIDE==wParam || SIZE_MINIMIZED==wParam)
                    g_bActive = FALSE;
             else   g_bActive = TRUE;
             break;
        case WM_SYSCOMMAND:
             switch(wParam)
             {  case SC_MOVE:
                case SC_SIZE:
                case SC_MAXIMIZE:
                case SC_MONITORPOWER:
                     return TRUE;
             }
             break;
        case WM_DESTROY:
             FreeDirectDraw();
             PostQuitMessage(0);
             return 0L;
    }

    return DefWindowProc(hWnd, msg, wParam, lParam);
}


